﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Threading;
using System.Windows;
using System.Xml.Linq;
using Infragistics.Olap;
using Infragistics.Olap.Data;
using Infragistics.Olap.FlatData;
using Infragistics.Controls.Grids;
using Infragistics.Documents.Excel;
using System.Threading.Tasks;

namespace SampleDynamicData
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : INotifyPropertyChanged
    {
        #region Fields

        private FlatDataSource maindata;
        private readonly Dictionary<string, int> levelNamesList = new Dictionary<string, int>();
        private readonly Dictionary<string, int> rowLevelNamesList = new Dictionary<string, int>();
        private ManualResetEvent manualResetEvent;
        public static int LevelDepth;
        public string pivotConfiguration = "";

        public string loadedConfig =
            "<?xml version=\"1.0\" encoding=\"utf-16\"?> " + Environment.NewLine +
            "<DataSourceSnapshot>" + Environment.NewLine +
            "  <DataSourceType>Flat</DataSourceType>" + Environment.NewLine +
            "  <Rows>" + Environment.NewLine +
            "    <FilterViewModel>" + Environment.NewLine +
            "      <HierarchyUniqueName>[RowData].[RowData]</HierarchyUniqueName>" + Environment.NewLine +
            "    </FilterViewModel>" + Environment.NewLine +
            "  </Rows>" + Environment.NewLine +
            "  <Columns>" + Environment.NewLine +
            "    <FilterViewModel>" + Environment.NewLine +
            "      <HierarchyUniqueName>[Vehicle Type].[Vehicle Type]</HierarchyUniqueName>" + Environment.NewLine +
            "       <NonSelectedFilterMembers>" + Environment.NewLine +
            "           <string>[Vehicle Type].[Vehicle Type].[Rating].&amp;[Honda]&amp;[CBR 650F]&amp;[2]</string>" + Environment.NewLine +
            "           <string>[Vehicle Type].[Vehicle Type].[Rating].&amp;[Honda]&amp;[CBR 650F]&amp;[5]</string>" + Environment.NewLine +
            "           <string>[Vehicle Type].[Vehicle Type].[Vehicle Name].&amp;[Honda]&amp;[Interceptor]</string>" + Environment.NewLine +
            "           <string>[Vehicle Type].[Vehicle Type].[Rating].&amp;[Yamaha]&amp;[R1]&amp;[4]</string>" + Environment.NewLine +
            "           <string>[Vehicle Type].[Vehicle Type].[Rating].&amp;[Yamaha]&amp;[R1]&amp;[5]</string>" + Environment.NewLine +
            "       </NonSelectedFilterMembers>" + Environment.NewLine +
            "    </FilterViewModel>" + Environment.NewLine +
            "  </Columns>" + Environment.NewLine +
            "  <Measures>" + Environment.NewLine +
            "    <string>UnitPrice</string>" + Environment.NewLine +
            "  </Measures>" + Environment.NewLine +
            "  <DefferedUpdate>false</DefferedUpdate>" + Environment.NewLine +
            "</DataSourceSnapshot>";

        public event PropertyChangedEventHandler PropertyChanged = delegate { } ;

        protected virtual void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public FlatDataSource Maindata
        {
            get
            {
                return maindata;
            }

            set
            {
                maindata = value;
                NotifyPropertyChanged("Maindata");
            }
        }
        #endregion

        public MainWindow()
        {
            InitializeComponent();            
            LoadData();            
            this.pivotGrid.DataSource = Maindata;
            //this.pivotGrid
            pivotGrid.CellControlAttached += pivotGrid_CellControlAttached;
            pivotGrid.Loaded += pivotGrid_Loaded;

            int no = 1;
            switch (no)
            {
                case 1:
                case 2:
                    no = 2;
                    break;
            }
        }

        void pivotGrid_Loaded(object sender, EventArgs e)
        {
            Maindata.LoadCustomizations(loadedConfig);
        }

        private List<string[]> Data()
        {
            var lst = new List<string[]>();
            string[] parentData = new string[] { "California", "Level 1", "Level 2", "3", "-3" };
            string[] parentData12 = new string[] { "California", "Level 1", "Level 2", "4", "-2" };
            string[] child1 = new string[] { "     California", "Level 1", "Level 2", "3", "-1" };
            //string[] child2 = new string[] { "     Los Angeles", "Honda", "CBR 1000R", "2", "12499" };
            string[] child3 = new string[] { "     Oakland", "Honda", "CBR 650F", "5", "15000" };
            string[] child4 = new string[] { "     Oakland", "Honda", "CBR 650F", "1", "15000" };
            string[] child5 = new string[] { "     Riverside", "Honda", "Interceptor", "3", "15999" };
            string[] child6 = new string[] { "     Riverside", "Honda", "CBR 650F", "2", "8499" };

            string[] parentData1 = new string[] { "Texas", "Yamaha", "R1", "1", null };
            string[] childv1 = new string[] { "     Houston", "Yamaha", "R1", "5", "11670" };
            string[] childv2 = new string[] { "     Houston", "Yamaha", "R1", "4", "12499" };
            string[] childv3 = new string[] { "     Dallas", "Yamaha", "R1", "5", "15000" };
            string[] childv4 = new string[] { "     Dallas", "Yamaha", "R6", "2", "15000" };
            string[] childv5 = new string[] { "     Dallas", "Yamaha", "R6", "3", "15999" };
            string[] childv6 = new string[] { "     Austin", "Yamaha", "R6", "1", "8499" };
            string[] childv7 = new string[] { "     Austin", "Yamaha", "R6", "4", "6499" };

            lst.Add(parentData);
            lst.Add(parentData12);
            //lst.Add(child1);
            //lst.Add(child2);
            //lst.Add(child3);
            //lst.Add(child4);
            //lst.Add(child5);
            //lst.Add(child6);

            //lst.Add(parentData1);
            //lst.Add(childv1);
            //lst.Add(childv2);
            //lst.Add(childv3);
            //lst.Add(childv4);
            //lst.Add(childv5);
            //lst.Add(childv6);
            //lst.Add(childv7);

            return lst;
        }

        void pivotGrid_CellControlAttached(object sender, Infragistics.Controls.Grids.PivotCellControlAttachedEventArgs e)
        {
            ICell cell = e.Cell.Data as ICell;
            if (cell != null && Convert.ToInt32(cell.Value) < 0)
                e.Cell.Control.Content = cell.FormattedValue.Replace("-", "(") + ")";
        }

        public async void LoadData()
        {
            var sourceTable = new DataTable();

            sourceTable.Columns.Add("RowData", typeof(string));
            sourceTable.Columns.Add("Vehicle Type", typeof(string));
            sourceTable.Columns.Add("Vehicle Type Temp", typeof(string));
            sourceTable.Columns.Add("VehicleName", typeof(string));
            sourceTable.Columns.Add("Rating", typeof(int));
            sourceTable.Columns.Add("UnitPrice", typeof(int));

            foreach (var elem in Data())
            {
                DataRow dr = sourceTable.NewRow();
                dr["RowData"] = elem[0];
                dr["Vehicle Type"] = elem[1];
                dr["Vehicle Type Temp"] = elem[1];
                dr["VehicleName"] = elem[2];
                dr["Rating"] = string.IsNullOrEmpty(elem[3]) ? 0 : Convert.ToInt32(elem[3]);
                dr["UnitPrice"] = string.IsNullOrEmpty(elem[4]) ? 0 : Convert.ToInt32(elem[4]);
                sourceTable.Rows.Add(dr);
            }

            sourceTable.AcceptChanges();

            Maindata = await BuildDataSource(sourceTable);
            //await Task.Factory.StartNew(
            //    () => BuildDataSource(sourceTable)).ContinueWith(Data_Comp);

        }

        private void Data_Comp(Task<Task<FlatDataSource>> obj)
        {
            Maindata = (FlatDataSource)(obj.Result).Result;
        }

        private async Task<FlatDataSource> BuildDataSource(DataTable table)
        {
            DynamicTypeBuilder typeBuilder = new DynamicTypeBuilder
            {
                DynamicAssemblyName = "MyAssembly",
                DynamicTypeName = "Data"
            };

            IList<DynamicTypePropertyInfo> properties = new List<DynamicTypePropertyInfo>();
            foreach (DataColumn column in table.Columns)
            {
                DynamicTypePropertyInfo propertyInfo = new DynamicTypePropertyInfo
                {
                    PropertyName = column.ColumnName,
                    PropertyType = (column.DataType == typeof(decimal) ? typeof(decimal?) : column.DataType)
                };

                properties.Add(propertyInfo);
            }

            Type dynamicType = typeBuilder.GenerateType(properties);

            Type listType = typeof(List<>);
            Type genericListType = listType.MakeGenericType(dynamicType);
            IList list = (IList)Activator.CreateInstance(genericListType);

            foreach (DataRow dataRow in table.Rows)
            {
                object myDynamicInstance = Activator.CreateInstance(dynamicType);
                foreach (DataColumn column in table.Columns)
                {
                    PropertyInfo propertyVal = dynamicType.GetProperty(column.ColumnName);
                    if (column.DataType == typeof(decimal))
                        propertyVal.SetValue(myDynamicInstance, dataRow[column].ToString() == "" ? null : dataRow[column], null);
                    if (dataRow[column] != DBNull.Value)
                        propertyVal.SetValue(myDynamicInstance, dataRow[column], null);
                }

                if (!string.IsNullOrEmpty(dataRow[0].ToString().Trim()))
                    list.Add(myDynamicInstance);
            }

            FlatDataSource flatDataSource = new FlatDataSource();

            #region Hierarchy

            flatDataSource.DimensionsGenerationMode = DimensionsGenerationMode.Mixed;

            CubeMetadata cubeMetadata = new CubeMetadata();
            cubeMetadata.DisplayName = "My Data";
            cubeMetadata.DataTypeFullName = typeBuilder.DynamicTypeName;  // Same as DynamicTypeName

            DimensionMetadata dm = new DimensionMetadata()
            {
                SourcePropertyName = "Rating",
                DisplayName = "Rating",
            };

            HierarchyDescriptor vehicleDescriptor = new HierarchyDescriptor()
            {
                SourcePropertyName = "Rating",
                HierarchyName = "Rating",
                HierarchyDisplayName = "Rating",
            };
            HierarchyLevelDescriptor allLevel = new HierarchyLevelDescriptor
            {
                LevelName = "All Rating Types",
            };
            vehicleDescriptor.LevelDescriptors.Add(allLevel);

            HierarchyLevelDescriptor level1 = new HierarchyLevelDescriptor
            {
                LevelName = "Rating",
                LevelExpressionPath = "Rating",
            };
            vehicleDescriptor.LevelDescriptors.Add(level1);
            HierarchyLevelDescriptor level2 = new HierarchyLevelDescriptor
            {
                LevelName = "Vehicle Type",
                LevelExpressionPath = "Vehicle Type",
            };            
            vehicleDescriptor.LevelDescriptors.Add(level2);

            HierarchyLevelDescriptor level3 = new HierarchyLevelDescriptor
            {
                LevelName = "Vehicle Name",
                LevelExpressionPath = "VehicleName",
            };

            vehicleDescriptor.LevelDescriptors.Add(level3);
            dm.HierarchyDescriptors.Add(vehicleDescriptor);

            cubeMetadata.DimensionSettings.Add(dm);
            flatDataSource.CubesSettings.Add(cubeMetadata);

            #endregion

            #region Hierarchy 1

            DimensionMetadata dm1 = new DimensionMetadata()
            {
                SourcePropertyName = "UnitPrice",
                DisplayName = "UnitPrice",
            };

            HierarchyDescriptor vehicleDescriptor1 = new HierarchyDescriptor()
            {
                SourcePropertyName = "UnitPrice",
                HierarchyName = "UnitPrice",
                HierarchyDisplayName = "UnitPrice",
            };

            HierarchyLevelDescriptor allLevel1 = new HierarchyLevelDescriptor
            {
                LevelName = "All Unit Types",
            };
            vehicleDescriptor1.LevelDescriptors.Add(allLevel1);


            HierarchyLevelDescriptor level11 = new HierarchyLevelDescriptor
            {
                LevelName = "UnitPrice",
                LevelExpressionPath = "UnitPrice",
            };
            vehicleDescriptor1.LevelDescriptors.Add(level11);
            HierarchyLevelDescriptor level21 = new HierarchyLevelDescriptor
            {
                LevelName = "Vehicle Type",
                LevelExpressionPath = "Vehicle Type",
            };
            vehicleDescriptor1.LevelDescriptors.Add(level21);

            HierarchyLevelDescriptor level31 = new HierarchyLevelDescriptor
            {
                LevelName = "Vehicle Name",
                LevelExpressionPath = "VehicleName",
            };

            vehicleDescriptor1.LevelDescriptors.Add(level31);
            dm1.HierarchyDescriptors.Add(vehicleDescriptor1);

            cubeMetadata.DimensionSettings.Add(dm1);
            flatDataSource.CubesSettings.Add(cubeMetadata);

            #endregion


            flatDataSource.ItemsSource = list;
            //flatDataSource.Cube = DataSourceBase.GenerateInitialCube("Data");
            //flatDataSource.Columns = DataSourceBase.GenerateInitialItems("[Vehicle Type].[Vehicle Type]");
            //flatDataSource.Rows = DataSourceBase.GenerateInitialItems("[RowData].[RowData]");
            //flatDataSource.Measures = DataSourceBase.GenerateInitialItems("UnitPrice, Rating");
            flatDataSource.ResultChanged += flatDataSource_ResultChanged;
            return flatDataSource;
        }

        void flatDataSource_ResultChanged(object sender, ResultChangedEventArgs e)
        {
            pivotConfiguration = ((Infragistics.Olap.DataSourceBase)(sender)).SaveCustomizations();
            // if you don't want to show totals, uncomment this code.
            //foreach (PivotDataColumn c in pivotGrid.DataColumns)
            //{
            //    if (c.IsTotal)
            //    {
            //        c.IsVisible = false;
            //    }
            //}
        }

        #region Excel Functionality


        private void ExportToExcel(object sender, RoutedEventArgs args)
        {
            this.SaveExport(this.CreateWorkbook(this.pivotGrid));
        }



        private Workbook CreateWorkbook(XamPivotGrid pivotGrid)
        {
            levelNamesList.Clear();
            rowLevelNamesList.Clear();
            Boolean CompactLayoutEnabled = pivotGrid.AllowCompactLayout;

            if (CompactLayoutEnabled)
                pivotGrid.AllowCompactLayout = false;

            int currentRow = 12;

            //Calculate the dimensions of the header rows and columns
            int TopHeaderHeight = 0;

            TopHeaderHeight = pivotGrid.GridLayout.PrivateRowsForColumnPanel.Count;

            int LeftHeaderWidth = 0;
            LeftHeaderWidth = pivotGrid.GridLayout.PrivateColumnsForRowPanel.Count;

            int currentCol = ((Infragistics.Olap.Data.Base.Hierarchy)(pivotGrid.DataSource.Rows[0].CompareKey)).Levels.Count;
            //Create the blank workbook and the sheet in it that will contain the PivotGrid data
            Workbook dataWorkbook = new Workbook();
            Worksheet sheet = dataWorkbook.Worksheets.Add("Report");

            sheet.DisplayOptions.PanesAreFrozen = true;
            sheet.DisplayOptions.FrozenPaneSettings.FrozenRows = TopHeaderHeight + currentRow;
            sheet.DisplayOptions.FrozenPaneSettings.FrozenColumns = LeftHeaderWidth;

            //Set default width for the columns
            sheet.DefaultColumnWidth = 6000;

            //First column set to 16000
            sheet.Columns[1].Width = 16000;

            int ColumnSpan, ColumnId, RowSpan, RowId;
            string CellValue;

            int i = 1;
            // Build Column Header
            foreach (PivotColumnHeaderCell cell in pivotGrid.GridLayout.ColumnHeaderCells.OrderByDescending(x => x.ColumnSpan))
            {
                ColumnSpan = cell.ColumnSpan;
                ColumnId = pivotGrid.GridLayout.Columns
                    .IndexOf(cell.Column as PivotDataColumn)
                           + LeftHeaderWidth;

                RowSpan = cell.RowSpan;
                RowId = pivotGrid.GridLayout
                    .PrivateRowsForColumnPanel.IndexOf(cell.Row as PivotHeaderRow) + currentRow;

                CellValue = cell.Member.Caption;
                if (!levelNamesList.ContainsKey(cell.Member.LevelName) && !CellValue.Equals("N/A"))
                {
                    levelNamesList.Add(cell.Member.LevelName, i);
                    i++;
                }
                if (cell.Member.IsTotal && cell.IsToggleVisible == false)
                    CellValue += " " + "Total";

                if (ColumnSpan > 1 || RowSpan > 1)
                {
                    sheet.MergedCellsRegions.Add(
                        RowId,
                        ColumnId,
                        RowId + RowSpan - 1,
                        ColumnId + ColumnSpan - 1
                        );

                    //Outline for Excel
                    for (int j = ColumnId; j <= ColumnId + ColumnSpan - 2; j++)
                    {
                        sheet.Columns[j].OutlineLevel = levelNamesList.FirstOrDefault(x => x.Key.Equals(cell.Member.LevelName)).Value;
                        sheet.Columns[j].Hidden = true;
                    }

                }
                if (CellValue.Equals("N/A"))
                {
                    sheet.Columns[ColumnId].Hidden = true;
                    continue;
                }
                this.SetCellValue(sheet.Rows[RowId].Cells[ColumnId], CellValue, "TopHeader");
            }


            // Build Row Header
            foreach (PivotRowHeaderCell cell in pivotGrid.GridLayout.RowHeaderCells.OrderByDescending(x => x.RowSpan))
            {
                ColumnSpan = cell.ColumnSpan;
                ColumnId = pivotGrid.GridLayout.PrivateColumnsForRowPanel.IndexOf(cell.Column as PivotHeaderColumn);

                RowSpan = cell.RowSpan;
                RowId = pivotGrid.GridLayout.Rows.IndexOf(cell.Row as PivotDataRow) + TopHeaderHeight + currentRow;

                CellValue = cell.Member.Caption;
                if (!rowLevelNamesList.ContainsKey(cell.Member.LevelName) && !CellValue.Equals("N/A"))
                {
                    rowLevelNamesList.Add(cell.Member.LevelName, i);
                    i++;
                }
                if (cell.Member.IsTotal && cell.IsToggleVisible == false)
                    CellValue += " " + "Total";

                if (ColumnSpan > 1 || RowSpan > 1)
                {
                    sheet.MergedCellsRegions.Add(
                        RowId,
                        ColumnId,
                        RowId + RowSpan - 1,
                        ColumnId + ColumnSpan - 1
                        );
                    //Outline for Excel
                    for (int j = RowId; j <= RowId + RowSpan - 2; j++)
                    {
                        sheet.Rows[j].OutlineLevel = rowLevelNamesList.FirstOrDefault(x => x.Key.Equals(cell.Member.LevelName)).Value;
                        sheet.Rows[j].Hidden = true;
                    }

                }
                if (CellValue.Equals("N/A"))
                {
                    sheet.Columns[ColumnId].Hidden = true;
                    continue;
                }

                this.SetCellValue(sheet.Rows[RowId].Cells[ColumnId], CellValue, "LeftHeader");
            }

            // Build Data
            foreach (PivotDataRow row in pivotGrid.GridLayout.Rows)
            {
                int currentCell = 0;
                foreach (PivotCell cell in row.Cells)
                {
                    string currentCellValue;
                    if (cell.Data != null)
                    {
                        currentCellValue = (cell.Data as ICell).FormattedValue;
                    }
                    else
                    {
                        currentCellValue = string.Empty;
                    }
                    if (cell.DataColumn.HeaderText.Contains("JV"))
                        SetCellValue(sheet.Rows[currentRow + TopHeaderHeight].Cells[currentCell + LeftHeaderWidth], currentCellValue, "Data with JV");
                    else if (cell.DataColumn.HeaderText.StartsWith("%"))
                        SetCellValue(sheet.Rows[currentRow + TopHeaderHeight].Cells[currentCell + LeftHeaderWidth], currentCellValue, "Data with %");
                    else
                        SetCellValue(sheet.Rows[currentRow + TopHeaderHeight].Cells[currentCell + LeftHeaderWidth], currentCellValue, "Data");
                    currentCell++;
                }
                currentRow++;
            }

            if (CompactLayoutEnabled)
                pivotGrid.AllowCompactLayout = true;

            //return the filled in workbook
            return dataWorkbook;

        }


        //Set the value and format each cell
        private void SetCellValue(WorksheetCell cell, string cellValue, string cellType)
        {
            cell.Value = cellValue;
            cell.CellFormat.ShrinkToFit = ExcelDefaultableBoolean.True;
            cell.CellFormat.VerticalAlignment = VerticalCellAlignment.Center;
            cell.CellFormat.Alignment = HorizontalCellAlignment.Center;

            if (cellType == "TopHeader")
            {
                cell.CellFormat.Fill = CellFill.CreatePatternFill(GetColor(255, 181, 212, 240), GetColor(255, 255, 255, 255), FillPatternStyle.Solid);
            }
            else if (cellType == "LeftHeader")
            {
                cell.CellFormat.Fill = CellFill.CreatePatternFill(GetColor(255, 200, 212, 240), GetColor(255, 255, 255, 255), FillPatternStyle.Solid);
            }
            else if (cellType == "Data")
            {
                cell.CellFormat.Fill = CellFill.CreatePatternFill(GetColor(255, 242, 244, 249), GetColor(255, 255, 255, 255), FillPatternStyle.Solid);
            }
            else
            {
                MessageBox.Show("Not located");
            }
        }

        private Color GetColor(int a, int r, int g, int b)
        {
            return Color.FromArgb(a, r, g, b);
        }

        //Open a dialog and prompt the user to save the Excel workbook with the exported data
        private void SaveExport(Workbook dataWorkbook)
        {
            string fileName = Path.GetTempFileName();
            fileName = fileName.Replace(".tmp", ".xlsx");
            dataWorkbook.SetCurrentFormat(WorkbookFormat.Excel2007);

            using (Stream stream = File.Open(fileName, FileMode.OpenOrCreate))
            {
                dataWorkbook.Save(stream);
                stream.Close();
            }

            System.Diagnostics.Process.Start(fileName);
        }

        #endregion

        #region Expand

        void DataSource_ResultChanged(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            DataSourceBase dataSourceBase = (DataSourceBase)sender;
            dataSourceBase.ResultChanged -= this.DataSource_ResultChanged;

            dataSourceBase.HierarchyExpansionMode = HierarchyExpansionMode.ExpandAll;
            dataSourceBase.UpdateVisualMembers(Infragistics.Olap.ExecutionContext.Rows);
            dataSourceBase.UpdateVisualMembers(Infragistics.Olap.ExecutionContext.Columns);

            dataSourceBase.RefreshGrid();
        }

        void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            DataSourceBase dataSource = e.Argument as DataSourceBase;

            IFilterViewModel fvm = FindViewModelByCaption(dataSource);
            if (fvm != null)
            {
                fvm.LoadFilterMembersCompleted += (sender1, e1) =>
                {
                    manualResetEvent.Set();
                };

                if (fvm != null && fvm.FilterMembers != null)
                {
                    foreach (IFilterMember member in fvm.FilterMembers)
                    {
                        DrillIn(fvm, member);
                    }
                }
            }
            else
            {
                this.Dispatcher.Invoke(
                    System.Windows.Threading.DispatcherPriority.Normal,
                    new Action(
                        delegate ()
                        {
                            MessageBox.Show("The Date hierarchy is not added to the row or column axises");
                        }));
            }
        }

        private IFilterViewModel FindViewModelByCaption(DataSourceBase dataSource)
        {

            for (int i = 0; i < dataSource.Rows.Count; i++)
            {
                if ((dataSource.Rows[i] as IFilterViewModel).Caption == "Vehicle Type")
                {
                    return dataSource.Rows[i] as IFilterViewModel;
                }
            }

            for (int i = 0; i < dataSource.Columns.Count; i++)
            {
                if ((dataSource.Columns[i] as IFilterViewModel).Caption == "Vehicle Type")
                {
                    return dataSource.Columns[i] as IFilterViewModel;
                }
            }

            return null;
        }

        private void DrillIn(IFilterViewModel filterViewModel, IFilterMember filterMember)
        {
            manualResetEvent = new ManualResetEvent(false);

            //Condition to drill in further
            if (filterMember.Member.LevelDepth < MainWindow.LevelDepth)
            {
                this.Dispatcher.Invoke(
                    System.Windows.Threading.DispatcherPriority.Normal,
                    new Action(
                        delegate ()
                        {
                            filterMember.IsExpanded = true;
                        }));

                if (filterMember.FilterMembers == null)
                    manualResetEvent.WaitOne();

                foreach (IFilterMember member in filterMember.FilterMembers)
                {
                    DrillIn(filterViewModel, member);
                }
            }
            else
            {
                this.Dispatcher.Invoke(
                    System.Windows.Threading.DispatcherPriority.Normal,
                    new Action(
                        delegate ()
                        {
                            filterMember.IsExpanded = false;
                        }));

            }
        }

        #endregion

        private void Expand_Click(object sender, RoutedEventArgs args)
        {
            //Here you should set the Depth of your Data
            MainWindow.LevelDepth = 15;

            BackgroundWorker worker = new BackgroundWorker();
            worker.DoWork += worker_DoWork;
            worker.RunWorkerCompleted += (s, e) =>
            {
                this.pivotGrid.DataSource.ResultChanged += DataSource_ResultChanged;
                this.pivotGrid.DataSource.DeferredLayoutUpdate = false;
            };
            this.pivotGrid.DataSource.DeferredLayoutUpdate = true;
            worker.RunWorkerAsync(this.pivotGrid.DataSource);
        }

        private void Load_Click(object sender, RoutedEventArgs e)
        {
            (pivotGrid.DataSource as FlatDataSource).LoadCustomizations(loadedConfig);
        }
    }
}
